package com.aliyun.imp.flutter.sdk.alicloud_impinteraction_sdk;

import androidx.annotation.NonNull;

import com.aliyun.imp.flutter.sdk.alicloud_impinteraction_sdk.plugin.FPHub;
import com.aliyun.roompaas.base.IDestroyable;
import com.aliyun.roompaas.base.log.Logger;
import com.aliyun.roompaas.base.util.Utils;

import io.flutter.embedding.engine.plugins.FlutterPlugin;
import io.flutter.embedding.engine.plugins.activity.ActivityAware;
import io.flutter.embedding.engine.plugins.activity.ActivityPluginBinding;
import io.flutter.plugin.common.MethodCall;
import io.flutter.plugin.common.MethodChannel;
import io.flutter.plugin.common.MethodChannel.Result;

/**
 * AlicloudImpinteractionSdkPlugin
 */
public class AlicloudImpinteractionSdkPlugin implements FlutterPlugin, MethodChannel.MethodCallHandler, ActivityAware, IDestroyable {
    public static final String TAG = "SDKPlugin";

    private FPHub pluginHub;

    @Override
    public void onAttachedToEngine(@NonNull FlutterPluginBinding binding) {
        Logger.i(TAG, "onAttachedToEngine: " + binding);
        ofHub().onAttachedToEngine(binding);
    }

    @Override
    public void onDetachedFromEngine(@NonNull FlutterPluginBinding binding) {
        Logger.i(TAG, "onDetachedFromEngine: " + binding);
        ofHub().onDetachedFromEngine(binding);
    }

    @SuppressWarnings("all")
    @Override
    public void onMethodCall(@NonNull MethodCall call, @NonNull Result result) {
        // do nothing, method channel will handle by itself
    }

    @Override
    public void onAttachedToActivity(@NonNull ActivityPluginBinding binding) {
        ofHub().onAttachedToActivity(binding);
    }

    @Override
    public void onDetachedFromActivityForConfigChanges() {
        ofHub().onDetachedFromActivityForConfigChanges();
    }

    @Override
    public void onReattachedToActivityForConfigChanges(@NonNull ActivityPluginBinding binding) {
        ofHub().onReattachedToActivityForConfigChanges(binding);
    }

    @Override
    public void onDetachedFromActivity() {
        ofHub().onDetachedFromActivity();
    }

    private FPHub ofHub(){
        if (pluginHub == null) {
            pluginHub = new FPHub();
        }

        return pluginHub;
    }

    @Override
    public void destroy() {
        Utils.destroy(pluginHub);
    }
}
