package com.aliyun.imp.flutter.sdk.alicloud_impinteraction_sdk;

import android.content.Context;

import androidx.annotation.NonNull;
import androidx.annotation.Nullable;

import com.aliyun.roompaas.base.log.Logger;

import java.util.Map;

import io.flutter.plugin.common.StandardMessageCodec;
import io.flutter.plugin.platform.PlatformView;
import io.flutter.plugin.platform.PlatformViewFactory;

public class NativeViewFactory extends PlatformViewFactory {
    public static final String TAG = "NativeViewFactory";

    public static NativeView sNativeView;

    public NativeViewFactory() {
        super(StandardMessageCodec.INSTANCE);
        Logger.i(TAG, "NativeViewFactory: construct");
    }

    @NonNull
    @Override
    public PlatformView create(@NonNull Context context, int id, @Nullable Object args) {
        return ofNativeView(context, id, (Map<String, Object>) args);
    }

    public static NativeView ofNativeView(@NonNull Context context, int id, @Nullable Map<String, Object> creationParams) {
        if (sNativeView == null) {
            sNativeView = new NativeView(context, id, creationParams);
        }

        return sNativeView;
    }
}
