package com.aliyun.imp.flutter.sdk.alicloud_impinteraction_sdk.plugin;

import androidx.annotation.NonNull;
import androidx.annotation.Nullable;

import com.aliyun.roompaas.base.util.Utils;

import java.util.Arrays;
import java.util.Collection;
import java.util.HashSet;
import java.util.Set;

import io.flutter.embedding.engine.plugins.activity.ActivityPluginBinding;

/**
 * Created by KyleCe on 2022/3/30
 */
public class FPHub extends FPAbstract {
    @Nullable
    private Set<FPAbstract> flutterPluginSet;

    public FPHub() {
    }

    @Override
    public void onAttachedToEngine(@NonNull FlutterPluginBinding binding) {
        for (FPAbstract fp : ofPlugins()) {
            if (fp == null) {
                continue;
            }

            fp.onAttachedToEngine(binding);
        }
    }

    private Collection<FPAbstract> ofPlugins() {
        if (flutterPluginSet != null) {
            return flutterPluginSet;
        }

        FPOfEvent event = new FPOfEvent();
        FPOfChat chat = new FPOfChat();
        FPOfLivePlayer livePlayer = new FPOfLivePlayer();
        FPOfLiverPusher liverPusher = new FPOfLiverPusher();
        FPOfRoomChannel roomChannel = new FPOfRoomChannel();
        FPOfRoomEngine roomEngine = new FPOfRoomEngine();

        flutterPluginSet = new HashSet<>();
        flutterPluginSet.addAll(Arrays.asList(event, chat, livePlayer, liverPusher, roomChannel, roomEngine));

        return flutterPluginSet;
    }

    @Override
    public void onDetachedFromEngine(@NonNull FlutterPluginBinding binding) {
        for (FPAbstract fp : ofPlugins()) {
            if (fp == null) {
                continue;
            }

            fp.onDetachedFromEngine(binding);
        }
    }

    @Override
    public void onAttachedToActivity(@NonNull ActivityPluginBinding binding) {
        for (FPAbstract fp : ofPlugins()) {
            if (fp == null) {
                continue;
            }

            fp.onAttachedToActivity(binding);
        }
    }

    @Override
    public void onDetachedFromActivityForConfigChanges() {
        for (FPAbstract fp : ofPlugins()) {
            if (fp == null) {
                continue;
            }

            fp.onDetachedFromActivityForConfigChanges();
        }
    }

    @Override
    public void onReattachedToActivityForConfigChanges(@NonNull ActivityPluginBinding binding) {
        for (FPAbstract fp : ofPlugins()) {
            if (fp == null) {
                continue;
            }

            fp.onReattachedToActivityForConfigChanges(binding);
        }
    }

    @Override
    public void onDetachedFromActivity() {
        for (FPAbstract fp : ofPlugins()) {
            if (fp == null) {
                continue;
            }

            fp.onDetachedFromActivity();
        }
    }

    @Override
    public void destroy() {
        if (flutterPluginSet != null) {
            Utils.destroy(flutterPluginSet.toArray());
            Utils.clear(flutterPluginSet);
            flutterPluginSet = null;
        }
    }
}
