//
//  AIMPSdkConf.m
//  Runner
//
//  Created by KyleCe on 2022/2/8.
//


#import <Flutter/Flutter.h>
#import "AIMPSUtils.h"

@interface AIMPSUtils ()

@end

@implementation AIMPSUtils

+ (void)callOK:(FlutterResult)result {
    [self callOK:result msg:@"true"];
}

+ (void)callOK:(FlutterResult _Nullable)result condition:(BOOL)condition {
    [self callOK:result msg:[self wrap:condition]];
}

+ (void)callOK:(FlutterResult)result msg:(NSString *_Nullable)msg {
    result(@{
            @"result": msg,
    });
}

+ (void)take:(FlutterResult)result dic:(NSMutableDictionary *_Nullable)dic {
    NSError *error;
    NSData *jsonData = [NSJSONSerialization dataWithJSONObject:dic
                                                       options:NSJSONWritingPrettyPrinted
                                                         error:&error];
    NSString *jsonString;
    if (jsonData) {
        jsonString = [[NSString alloc] initWithData:jsonData encoding:NSUTF8StringEncoding];
    } else {
        NSLog(@"Got an error: %@", error);
        jsonString = @"";
    }
    NSLog([NSString stringWithFormat:@"AAA iOS take: %@", jsonString]);
    result(@{
            @"result": jsonString,
    });
}

+ (void)callErr:(FlutterResult)result {
    [self callErr:result msg:@"error"];
}

+ (void)callErr:(FlutterResult)result msg:(NSString *_Nullable)msg {
    result([FlutterError errorWithCode:@"10001"
                               message:msg
                               details:nil]);
}

+ (NSString *)wrap:(BOOL)condition {
    return condition ? @"true" : @"false";
}

+ (NSString *)wrapInvalidParam:(NSString *)key {
    return [NSString stringWithFormat:@"invalid param: must have '%@' key-value pair", key];
}

@end

