#import "AlicloudImpinteractionSdkPlugin.h"
#import "IMPChatModule.h"
#import "IMPLivePusherComponent.h"
#import "IMPLivePlayerComponent.h"
#import "IMPRoomChannelModule.h"
#import "IMPRoomEngineModule.h"
#import "IMPEvent.h"

#import "FLNativeView.h"

@implementation AlicloudImpinteractionSdkPlugin

+ (void)registerWithRegistrar:(NSObject <FlutterPluginRegistrar> *)registrar {
    FlutterEventChannel *channel = [FlutterEventChannel eventChannelWithName:@"alicloud_impinteraction_sdk_event" binaryMessenger:[registrar messenger]];
    [channel setStreamHandler:[[IMPEvent ins] init]];

    [self register:registrar tag:@"alicloud_impinteraction_sdk_chat" ins:[[IMPChatModule alloc] init]];
    [self register:registrar tag:@"alicloud_impinteraction_sdk_live_pusher" ins:[[IMPLivePusherComponent alloc] init]];
    [self register:registrar tag:@"alicloud_impinteraction_sdk_live_player" ins:[[IMPLivePlayerComponent alloc] init]];
    [self register:registrar tag:@"alicloud_impinteraction_sdk_room_channel" ins:[[IMPRoomChannelModule alloc] init]];
    [self register:registrar tag:@"alicloud_impinteraction_sdk_room_engine" ins:[[IMPRoomEngineModule alloc] init]];

    FLNativeViewFactory *factory = [[FLNativeViewFactory sharedInstance] initWithMessenger:registrar.messenger];
    [registrar registerViewFactory:factory withId:@"<platform-view-type>"];
}

+ (void)register:(NSObject <FlutterPluginRegistrar> *)registrar tag:(NSString *)tag ins:(NSObject <FlutterPlugin> *)ins {
    FlutterMethodChannel *ch = [FlutterMethodChannel methodChannelWithName:tag binaryMessenger:[registrar messenger]];
    [registrar addMethodCallDelegate:ins channel:ch];
}

@end
