//
//  IMPRoomChannelManager.h
//  alicloud-IMPInteractionRoomUniPlugin
//
//  Created by fernando on 2022/3/2.
//

#import <Foundation/Foundation.h>

@import AliInteractiveRoomBundle;

NS_ASSUME_NONNULL_BEGIN


@interface IMPRoomChannelManager : NSObject<AIRBRoomChannelDelegate>
@property (strong, nonatomic) id<AIRBRoomChannelProtocol> room;
@property (copy, nonatomic) NSString* roomID;

@property (copy, nonatomic) void(^onRoomEvent)(AIRBRoomChannelEvent event, NSDictionary* info);
@property (copy, nonatomic) void(^onRoomError)(AIRBErrorCode code ,NSString * message);

@property (copy, nonatomic) void(^onReceiveRoomMessage)(AIRBRoomChannelMessageType type, NSDictionary* info);
@property (copy, nonatomic) void(^onReceiveChatMessage)(AIRBRoomChannelMessageType type, NSDictionary* info);

+ (IMPRoomChannelManager*)sharedInstance;
- (void) setupWithRoomID:(NSString*)roomID;


@end

NS_ASSUME_NONNULL_END
