//
//  IMPRoomChannelManager.m
//  alicloud-IMPInteractionRoomUniPlugin
//
//  Created by fernando on 2022/3/2.
//

#import "IMPRoomChannelManager.h"

@interface IMPRoomChannelManager()


@end

@implementation IMPRoomChannelManager


+ (IMPRoomChannelManager*) sharedInstance {
    static IMPRoomChannelManager *sharedInstance = nil;
    static dispatch_once_t onceToken;
    dispatch_once(&onceToken, ^{
        sharedInstance = [[IMPRoomChannelManager alloc] init];
    });
    return sharedInstance;
}

- (void) setupWithRoomID:(NSString *)roomID {
    _roomID = roomID;
    _room = [[AIRBRoomEngine sharedInstance] getRoomChannelWithRoomID:_roomID bizType:@"" bizID:nil];
}

#pragma mark -AIRBRoomChannelDelegate
- (void) onAIRBRoomChannelEvent:(AIRBRoomChannelEvent)event info:(NSDictionary *)info {
    if (event == AIRBRoomChannelEventMessageReceived) {
        AIRBRoomChannelMessageType type = [[info valueForKey:@"type"] intValue];
        NSData *turnData = [[info valueForKey:@"data"] dataUsingEncoding:NSUTF8StringEncoding];
        NSDictionary *dataDic = [NSJSONSerialization JSONObjectWithData:turnData options:NSJSONReadingMutableLeaves error:nil];
        if (self.onReceiveRoomMessage) {
            self.onReceiveRoomMessage(type, dataDic);
        }
        if (self.onReceiveChatMessage) {
            self.onReceiveChatMessage(type, dataDic);
        }
    } else {
        if (self.onRoomEvent) {
            self.onRoomEvent(event, info);
        }
    }
}

- (void) onAIRBRoomChannelErrorWithCode:(AIRBErrorCode)code message:(NSString *)message {
    if (self.onRoomError) {
        self.onRoomError(code, message);
    }
}
@end
