import 'dart:async';

import 'package:flutter/services.dart';
import 'utils.dart';

class IMPSdkChat {
  static const channelTag = 'alicloud_impinteraction_sdk_chat';
  static const MethodChannel _mc = MethodChannel(channelTag);

  /// returns the result of api in format of [Result]
  static Future<M> getChatDetail([M p]) async {
    return LUtils.asM(await _mc.invokeMethod('getChatDetail', p));
  }

  /// returns the result of api in format of [Result]
  static Future<M> sendComment([M p]) async {
    return LUtils.asM(await _mc.invokeMethod('sendComment', p));
  }

  /// returns the result of api in format of [Result]
  static Future<M> sendCustomMessageToAll([M p]) async {
    return LUtils.asM(await _mc.invokeMethod('sendCustomMessageToAll', p));
  }

  /// returns the result of api in format of [Result]
  static Future<M> sendCustomMessageToUsers([M p]) async {
    return LUtils.asM(await _mc.invokeMethod('sendCustomMessageToUsers', p));
  }

  /// returns the result of api in format of [Result]
  static Future<M> banComment([M p]) async {
    return LUtils.asM(await _mc.invokeMethod('banComment', p));
  }

  /// returns the result of api in format of [Result]
  static Future<M> cancelBanComment([M p]) async {
    return LUtils.asM(await _mc.invokeMethod('cancelBanComment', p));
  }

  /// returns the result of api in format of [Result]
  static Future<M> banAllComment([M p]) async {
    return LUtils.asM(await _mc.invokeMethod('banAllComment', p));
  }

  /// returns the result of api in format of [Result]
  static Future<M> cancelBanAllComment([M p]) async {
    return LUtils.asM(await _mc.invokeMethod('cancelBanAllComment', p));
  }

  /// returns the result of api in format of [Result]
  static Future<M> sendLike([M p]) async {
    return LUtils.asM(await _mc.invokeMethod('sendLike', p));
  }

  /// returns the result of api in format of [Result]
  static Future<M> listComment([M p]) async {
    return LUtils.asM(await _mc.invokeMethod('listComment', p));
  }
}
