import 'dart:async';

import 'package:flutter/services.dart';
import 'utils.dart';

class IMPSdkLivePusher {
  static const channelTag = 'alicloud_impinteraction_sdk_live_pusher';
  static const MethodChannel _mc = MethodChannel(channelTag);

  /// returns the result of api in format of [Result]
  static Future<M> startPreview([M p]) async {
    return LUtils.asM(await _mc.invokeMethod('startPreview', p));
  }

  /// returns the result of api in format of [Result]
  static Future<M> toggleBeautyPanel([M p]) async {
    return LUtils.asM(await _mc.invokeMethod('toggleBeautyPanel', p));
  }

  /// returns the result of api in format of [Result]
  static Future<M> startLive([M p]) async {
    return LUtils.asM(await _mc.invokeMethod('startLive', p));
  }

  /// returns the result of api in format of [Result]
  static Future<M> setPreviewMode([M p]) async {
    return LUtils.asM(await _mc.invokeMethod('setPreviewMode', p));
  }

  /// returns the result of api in format of [Result]
  static Future<M> switchCamera([M p]) async {
    return LUtils.asM(await _mc.invokeMethod('switchCamera', p));
  }

  /// returns the result of api in format of [Result]
  static Future<M> setPreviewMirror([M p]) async {
    return LUtils.asM(await _mc.invokeMethod('setPreviewMirror', p));
  }

  /// returns the result of api in format of [Result]
  static Future<M> setPushMirror([M p]) async {
    return LUtils.asM(await _mc.invokeMethod('setPushMirror', p));
  }

  /// returns the result of api in format of [Result]
  static Future<M> stopLive([M p]) async {
    return LUtils.asM(await _mc.invokeMethod('stopLive', p));
  }
}
