import 'dart:async';

import 'package:flutter/services.dart';
import 'utils.dart';

class IMPSdkRoomChannel {
  static const channelTag = 'alicloud_impinteraction_sdk_room_channel';
  static const MethodChannel _mc = MethodChannel(channelTag);

  /// returns the result of api in format of [Result]
  static Future<M> getRoomId([M p]) async {
    return LUtils.asM(await _mc.invokeMethod('getRoomId', p));
  }

  /// returns the result of api in format of [Result]
  static Future<M> isOwner([M p]) async {
    return LUtils.asM(await _mc.invokeMethod('isOwner', p));
  }

  /// returns the result of api in format of [Result]
  static Future<M> isAdmin([M p]) async {
    return LUtils.asM(await _mc.invokeMethod('isAdmin', p));
  }

  /// returns the result of api in format of [Result]
  static Future<M> setRoomId([M p]) async {
    return LUtils.asM(await _mc.invokeMethod('setRoomId', p));
  }

  /// returns the result of api in format of [Result]
  static Future<M> enterRoom([M p]) async {
    return LUtils.asM(await _mc.invokeMethod('enterRoom', p));
  }

  /// returns the result of api in format of [Result]
  static Future<M> leaveRoom([M p]) async {
    return LUtils.asM(await _mc.invokeMethod('leaveRoom', p));
  }

  /// returns the result of api in format of [Result]
  static Future<M> listUser([M p]) async {
    return LUtils.asM(await _mc.invokeMethod('listUser', p));
  }

  /// returns the result of api in format of [Result]
  static Future<M> getRoomDetail([M p]) async {
    return LUtils.asM(await _mc.invokeMethod('getRoomDetail', p));
  }

  /// returns the result of api in format of [Result]
  static Future<M> kickUser([M p]) async {
    return LUtils.asM(await _mc.invokeMethod('kickUser', p));
  }
}
