import 'dart:async';

import 'package:flutter/services.dart';
import 'utils.dart';

class IMPSdkRoomEngine {
  static const channelTag = 'alicloud_impinteraction_sdk_room_engine';
  static const MethodChannel _mc = MethodChannel(channelTag);

  /// returns the result of api in format of [Result]
  static Future<M> init([M p]) async {
    return LUtils.asM(await _mc.invokeMethod('init', p));
  }

  /// returns the result of api in format of [Result]
  static Future<M> login([M p]) async {
    return LUtils.asM(await _mc.invokeMethod('login', p));
  }

  /// returns the result of api in format of [Result]
  static Future<M> setLoginToken([M p]) async {
    return LUtils.asM(await _mc.invokeMethod('setLoginToken', p));
  }

  /// returns the result of api in format of [Result]
  static Future<M> logout([M p]) async {
    return LUtils.asM(await _mc.invokeMethod('logout', p));
  }

  /// returns the result of api in format of [Result]
  static Future<M> isLogined([M p]) async {
    return LUtils.asM(await _mc.invokeMethod('isLogined', p));
  }
}
